package de.uni.kiel.proki.ws1112.muehle.interfaces;


/**
 * Jeder Spieler soll dieses Interface erfuellen.
 *
 * @author wzo
 */
public interface PlayerInterface {

	/**
	 * Hiermit soll ein Spieler benachrichtigt werden, 
	 * dass dieser am Zug ist und nach den Regeln
	 * von Phase 1. spielen soll.
	 * 
	 * @param model - Der aktuelle Spielfeldzustand
	 * @return - Den gewaehlten/berechneten Move
	 */
	public Move getNextSetMove(ModelInterface model);

	/**
	 * 
	 * Hiermit soll ein Spieler benachrichtigt werden, 
	 * dass dieser am Zug ist und nach den Regeln
	 * von Phase 1. spielen soll.
	 * 
	 * @param model - Der aktuelle Spielfeldzustand
	 * @param time die Zeit, die der Spieler zum ziehen hat
	 * @return - Den gewaehlten/berechneten Move
	 */
	public Move getNextSetMove(ModelInterface model, int time);

	/**
	 * Hiermit soll ein Spieler benachrichtigt werden, 
	 * dass dieser am Zug ist und nach den Regeln
	 * von Phase 2. spielen soll
	 * 
	 * @param model - Der aktuelle Spielfeldzustand
	 * @return - Den gewaehlten/berechneten Move
	 */
	public Move getNextMove(ModelInterface model);
	/**
	 * Hiermit soll ein Spieler benachrichtigt werden, 
	 * dass dieser am Zug ist und nach den Regeln
	 * von Phase 2. spielen soll
	 * 
	 * @param model - Der aktuelle Spielfeldzustand
	 * @param time die Zeit, die der Spieler zum ziehen hat
	 * @return - Den gewaehlten/berechneten Move
	 */
	public Move getNextMove(ModelInterface model, int time);

	/**
	 * Hiermit soll ein Spieler benachrichtigt werden, 
	 * dass dieser am Zug ist und dem Gegner einen
	 * Stein wegnehmen darf.
	 * 
	 * @param model - Der aktuelle Spielfeldzustand
	 * @return - Den gewaehlten/berechneten Move
	 */
	public Move getRemoveMove(ModelInterface model);

	/**
	 * Hiermit soll ein Spieler benachrichtigt werden, 
	 * dass dieser am Zug ist und dem Gegner einen
	 * Stein wegnehmen darf.
	 * 
	 * @param model - Der aktuelle Spielfeldzustand
	 * @param time die Zeit, die der Spieler zum ziehen hat
	 * @return - Den gewaehlten/berechneten Move
	 */
	public Move getRemoveMove(ModelInterface model, int time);

	/**
	 * Weist dem Spieler eine Farbe zu.
	 * 
	 * @param spielerfarbe Token.RED oder Token.BLUE
	 */
	public void setColor(Token spielerfarbe);

	/**
	 * Gibt die Farbe des Spieler zurueck.
	 * 
	 * @return spielerfarbe des Spielers
	 *	       Token.RED oder Token.BLUE
	 */
	public Token getColor();
}
